﻿// Copyright (c) 2007 Pairwise Inc
// All rights reserved
// 
// http://www.likebetter.com

// LIKEBETTER BEST IMAGE DISPLAY

var IMAGE_SIZE = 200;
var IMAGE_URL = "";
var HOSTNAME = "http://www.likebetter.com";
var logoRequest_ = null;
var winShell = new ActiveXObject("Shell.Application");
options.putDefaultValue("channel_count",20);
options.putDefaultValue("channel_name","Funniest");

var nextImage = 1;
var image1_front = true;
/**
 * How long the fade effect should last (in milliseconds)
 */
var FADE_DURATION = 2000;
/**
 * Interval (in milliseconds) between fades
 */
var FADE_INTERVAL = 8000;

function openResults() {
	  winShell.ShellExecute(HOSTNAME + '/channel/'+options.getValue("channel_name")+'/info'); 
}

function openOptions() {
  // Show the options dialog.
  pluginHelper.showOptionsDialog();
}

//function startRefresh(){	
 //setInterval( "onOpen();alert('hi')", 5000 );
//}

function onOptionChanged() {
getImage(1);
}

function getImage(ranking) {
  logoRequest_ = new XMLHttpRequest();
 
  IMAGE_URL = HOSTNAME + "/channel/"+ options.getValue('channel_name') + "/best/" + IMAGE_SIZE + "?ranking=" + ranking +"&q="+ Math.random();
 
  try {
    logoRequest_.open("GET", IMAGE_URL, true);
	
  } catch (e) {
    // Catch invalid URLs
	statusLabel.visible = true;
    statusLabel.innerText = FAILED;
    logoRequest_ = null;
    return;
  }

  // Set the callback for when the downloading is completed (or failed)
  logoRequest_.onreadystatechange = onLogoData;

  // Start the download
  try {
    logoRequest_.send();
  } catch (e) {
    // Catch errors sending the request
	statusLabel.visible = true;
    statusLabel.innerText = FAILED;
    logoRequest_ = null;
    return;
  }
  
  
}

function onLogoData() {
  // Verify that the download completed
  
  if (logoRequest_.readyState != 4)
    return;

  // Verify that the download was successful
  if (logoRequest_.status != 200) {
    statusLabel.visible = true;
    statusLabel.innerText = FAILED;
    logoRequest_ = null;
    return;
  }

  // Obtain the stream of image data and set it as the image. If you were
  // just downloading text, you could use .responseText to get the text content
  // of the URL you specified.
  var new_src;
  new_src = logoRequest_.responseStream;
  //imageControl.visible = true;
  //statusLabel.visible = false;
  
  if (image1_front) {
	image_out = image1;
	image_in = image2;
	image2.src=new_src
	image1_front=false;
  } else {
	image_out = image2;
	image_in = image1;
	image1.src=new_src
	image1_front=true;
  }
  view.beginAnimation(function() { setElementOpacity(image_out); }, // callback
                      255, // start value, 255 = full opacity
                      0, // end value, 0 = no opacity or "hidden"
                      FADE_DURATION); // duration in milliseconds

  view.beginAnimation(function() { setElementOpacity(image_in); }, // callback
                      0, // start value 0 = no opacity or "hidden"
                      255, // end value, 255 = full opacity
                      FADE_DURATION); // duration in milliseconds  

  // Destroy the XMLHttpRequest object since it isn't being used anymore
  logoRequest_ = null;
}


/**
 * view "onopen" handler
 */
function onOpen() {
  // Must call initial fade effect ourselves.
  // "view.setInterval" does not perform an initial call.
  fadeImages();
  // Create run forever timer
  view.setInterval(fadeImages, FADE_INTERVAL);
}  

/**
 * Fade the next image in and the previous image out
 */
function fadeImages() {
  
  nextImage++;
  if (nextImage > options.getValue("channel_count")) {
	nextImage=1;
  }
 
  getImage(nextImage);                  
}

/**
 * To be called by "view.beginAnimation".
 * "event.value" holds the interpolated value between
 * "view.beginAnimation"'s start value and end value parameters.
 * @param {view.BasicElement}
 */
function setElementOpacity(element) {
  element.opacity = event.value;
}